# exlap.rb version 1.03: (coding: Windows-31J)  2011/02/19
  # Excel(OLE control)̂߂̃Cu
  # Copyright (C) T. Yoshiizumi, 2009-2011 All rights reserved.
require 'win32ole'

# excel̃Z܂̓ZQ̔ԒnԂ\bh
  def rc(rng, opt = :ABSOLUTE)  # rc(yx)W̐lŕԂ
    res = nil
    opt_v = opt == :ABSOLUTE ? true : false
    begin
      a = rng.Address({'RowAbsolute'=>opt_v, 'ColumnAbsolute'=>opt_v,
          'ReferenceStyle'=>-4150})  # -4150 = XlR1C1
      if a =~ /^R(\d+)C(\d+)$/i
        res = [$1.to_i, $2.to_i]
      elsif a =~ /^R(\d+)C(\d+)\:R(\d+)C(\d+)$/i
        res = [$1.to_i, $2.to_i, $3.to_i, $4.to_i]
      elsif a =~ /^R\[(\d+)\]C\[(\d+)\]$/i
        res = [$1.to_i, $2.to_i]
      elsif a =~ /^R\[(\d+)\]C\[(\d+)\]\:R\[(\d+)\]C\[(\d+)\]$/i
        res = [$1.to_i, $2.to_i, $3.to_i, $4.to_i]
      end
    rescue
      res = nil
    end
    return res
  end
  alias :yx :rc

  def ab(rng, opt=:ABSOLUTE)  # $A$1:$D$4 Ȃǂ̌`ŕԂ
    res = nil
    begin
      opt_v = opt == :ABSOLUTE ? true : false
      a = rng.Address({'RowAbsolute'=>opt_v, 'ColumnAbsolute'=>opt_v,
          'ReferenceStyle'=>1})  # 1=XlA1
      res = a
    end
    return res
  end

  def a1(rng)
    res = ab(rng)
    if res
      res = res.gsub(/\$/, "")
    end
    return res
  end


# [NV[g̃ZƂ̏Wg₷邽߂̊gW[
module Exlsheet
  def [] y,x
    tcell = self.Cells.Item(y,x)
    if tcell.MergeCells
      tcell.MergeArea.Item(1,1).Value
    else
      tcell.Value
    end
  end

  def []= y,x,value
    tcell = self.Cells.Item(y,x)
    if tcell.MergeCells
      tcell.MergeArea.Item(1,1).Value = value
    else
      tcell.Value = value
    end
  end

  def cell(y, x)
    return self.Cells.Item(y,x)
  end

  def to_a
    res = []
    ymax,xmax = self.range_last
    for y in 1..ymax
      w = []
      for x in 1..xmax
        w << self.Cells.Item(y,x).Value
      end
      w.shift  if w == [nil]
      res << w
    end
    res.shift  if res == [[]]
    return res
  end

  def range_to_a(rng = nil)
    res = []
    if rng == nil
      rng = self.UsedRange
    end
    rng.Rows.each {|row|
      record = []
      row.Columns.each {|col|
        record << col.Value
      }
      record.shift  if record == [nil]
      res << record
    }
    res.shift  if res == [[]]
    return res
  end

  def range_address(rng = :NONE, opt = :ABSOLUTE)
    if rng == :NONE
      rng = self.UsedRange
    elsif [Regexp,String,Fixnum,Bignum,Float,NilClass].include?(rng.class)
      rng = self.rip_range(rng)
    end
    res = rc(rng, opt)
    return res
  end

  def range_last(rng = :NONE, opt = :ABSOLUTE)  # ^̗̖̈Ԓn
    res = self.range_address(rng, opt)
    while res.size > 2
      res.shift
    end
    return res
  end

  def range_start(rng = :NONE, opt = :ABSOLUTE)  # ^̗̈̐擪ZԒn
    res = self.range_address(rng, opt)
    while res.size > 2
      res.pop
    end
    return res
  end

  def rip_range(*opt)
    if opt.size == 0
      return self.UsedRange
    end
    types = Array.new
    opt.each {|x|
      if [Fixnum,Bignum].include?(x.class)
        types << :NUMBER
      elsif [String,Regexp].include?(x.class)
        types << :STRING
      else
        types << :OTHER
      end
    }
    tcells = Array.new
    i = 0
    while i < types.size
      if types[i] == :NUMBER and types[i+1] == :NUMBER
        tcells << self.cell(opt[i], opt[i+1])
        i = i + 2
      elsif types[i] == :STRING
        tcells << self.findf(opt[i])
        i = i + 1
      else
        tcells.clear
        break
      end
    end
    rng = nil
    if tcells.size == 2
      rng = self.Range(tcells[0], tcells[1])
    elsif tcells.size == 1
      y,x = self.range_last
      rng = self.Range(tcells[0], self.cell(y,x))
    end
    return rng
  end
  alias :rr :rip_range

  def range_pole(rng = :NONE)  # ɂ̃ZIuWFNgԂ
    res = []
    w = self.range_address(rng)
    if w.size == 4
      res << self.Cells.Item(w[0], w[1])
      res << self.Cells.Item(w[2], w[3])
    end
    return res
  end
  alias :rp :range_pole
  alias :range_pair :range_pole

  def entire_range  # gĂ̈S(n_A1)Ԃ
    y,x = self.range_last
    self.Range(self.Cells.Item(1,1), self.Cells.Item(y,x))
  end

  def range_autofit(rng = nil)
    unless rng
      rng = self.UsedRange
    end
    rng.Columns.each {|col|  col.AutoFit}
    rng.Rows.each {|row|  row.AutoFit}
  end

  def range_allbox(rng=nil, opt={})
    unless rng
      rng = self.UsedRange
    end
    opt['LineStyle'] = 1  unless opt['LineStyle']  # XlContinuous 
    opt['Weight'] = 2  unless opt['Weight']  # XlThin א
    opt['ColorIndex'] = -4105 unless opt['ColorIndex'] # XlAutomatic ݒ
    bd = rng.Borders
    bd.LineStyle = opt['LineStyle']
    bd.Weight = opt['Weight']
    bd.ColorIndex = opt['ColorIndex']
  end

  def range_doublebox(rng=nil, opt={})
    unless rng
      rng = self.UsedRange
    end
    opt['LineStyle'] = 1  unless opt['LineStyle']  # XlContinuous 
    opt['Weight'] = 2  unless opt['Weight']  # XlThin א
    opt['ColorIndex'] = -4105 unless opt['ColorIndex'] # XlAutomatic ݒ
    opt['Frame'] = -4138  unless opt['Frame']  # XlMedium OgE
        # i
    bd1 = rng.Borders(XlEdgeTop)
    bd1.LineStyle = opt['LineStyle']
    bd1.Weight = opt['Frame']
    bd1.ColorIndex = opt['ColorIndex']
        # i
    bd2 = rng.Borders(XlEdgeBottom)
    bd2.LineStyle = opt['LineStyle']
    bd2.Weight = opt['Frame']
    bd2.ColorIndex = opt['ColorIndex']
        # 
    bd3 = rng.Borders(XlEdgeLeft)
    bd3.LineStyle = opt['LineStyle']
    bd3.Weight = opt['Frame']
    bd3.ColorIndex = opt['ColorIndex']
        # E
    bd4 = rng.Borders(XlEdgeRight)
    bd4.LineStyle = opt['LineStyle']
    bd4.Weight = opt['Frame']
    bd4.ColorIndex = opt['ColorIndex']
        # ̏c
    bd5 = rng.Borders(XlInsideVertical)
    bd5.LineStyle = opt['LineStyle']
    bd5.Weight = opt['Weight']  # א
    bd5.ColorIndex = opt['ColorIndex']
        # ̉
    bd6 = rng.Borders(XlInsideHorizontal)
    bd6.LineStyle = opt['LineStyle']
    bd6.Weight = opt['Weight']
    bd6.ColorIndex = opt['ColorIndex']
  end

  def range_clearbox(rng=nil)
    unless rng
      rng = self.UsedRange
    end
    rng.Borders.LineStyle = -4142  # XlLineStyleNone(r)
  end

  def findf(key, prop=nil)  # propValueȂǂ̃vpeB
    tcell = nil
    if prop == nil or prop.downcase == 'value'
      if key.class == Regexp
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key =~ col.Value.to_s
              tcell = col
              break
            end
          }
          break  if tcell
        }
      elsif [String,Fixnum,Bignum,Float,NilClass,TrueClass,
          FalseClass].include?(key.class)
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key == col.Value
              tcell = col
              break
            end
          }
          break  if tcell
        }
      end
    else
      if key.class == Regexp
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key =~ eval("col.#{prop}.to_s")
              tcell = col
              break
            end
          }
          break  if tcell
        }
      elsif [String,Fixnum,Bignum,Float,NilClass,TrueClass,
          FalseClass].include?(key.class)
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key == eval("col.#{prop}")
              tcell = col
              break
            end
          }
          break  if tcell
        }
      end
    end
    return tcell
  end

  def finda(key, prop=nil)
    res = []
    if prop == nil or prop.downcase == 'value'
      if key.class == Regexp
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key =~ col.Value.to_s
              if block_given?
                yield col
              else
                res << col
              end
            end
          }
        }
      elsif [String,Fixnum,Bignum,Float,NilClass,TrueClass,
          FalseClass].include?(key.class)
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key == col.Value
              if block_given?
                yield col
              else
                res << col
              end
            end
          }
        }
      end
    else
      if key.class == Regexp
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key =~ eval("col.#{prop}.to_s")
              if block_given?
                yield col
              else
                res << col
              end
            end
          }
        }
      elsif [String,Fixnum,Bignum,Float,NilClass,TrueClass,
          FalseClass].include?(key.class)
        self.UsedRange.Rows.each {|row|
          row.Columns.each {|col|
            if key == eval("col.#{prop}")
              if block_given?
                yield col
              else
                res << col
              end
            end
          }
        }
      end
    end
    return res
  end

  def hyperlink(*opt)
    tcell = nil
    uri = nil
    text = nil
    if [Fixnum,Bignum].include?(opt[0].class) and [3,4].include?(opt.size)
      begin
        tcell = self.Cells.Item(opt[0], opt[1])
      rescue
        tcell = nil
      end
      uri = opt[2]
      text = opt[3]  if opt.size == 4
    elsif opt[0].class == String and opt[0] =~ /^[A-Z]+\d+$/i and
          [2,3].include?(opt.size)
      begin
        tcell = self.Range(opt[0].upcase)
      rescue
        tcell = nil
      end
      uri = opt[1]
      text = opt[2]  if opt.size == 3
    end
    if tcell == nil or uri == nil
      STDERR.puts "Error: hyperlink\bh̃p[^̎w肪sKł."
      STDERR.printf("(%s)\n\n", opt.join(","))
      return
    end
    if text
      hs = {'Anchor'=>tcell, 'Address'=>uri, 'TextToDisplay'=>text}
      self.Hyperlinks.Add(hs)
    else
      hs = {'Anchor'=>tcell, 'Address'=>uri}
      self.Hyperlinks.Add(hs)
    end
  end
end


# w̃t@CtpXŕԂ
def getAbsolutePath(fname)
  fso = WIN32OLE.new('Scripting.FileSystemObject')
  return fso.GetAbsolutePathName(fname)
end

# t@C̊gq .xls ȂǂɂȂ悤
def filename_arrange(fname)
  w = fname.gsub(/\\/, "/")
  e = File.extname(w)
  d = File.dirname(w)
  f = File.basename(w, ".*")
  if d != ""
    d = d.sub(/\/$/, "")
    d = d.gsub(/\//, "\\") + "\\"
  end
  res = d + f
  if $ext_type[e.downcase] != nil
    res = res + e
  else
    res = res + ".xls"
  end
  return res
end

    # Excel֌W̒萔[邽߂̃W[(ۂł܂Ȃ)
module ExlConstant
end

# Excel[NubN߂̃NX
class Exlwb
  include ExlConstant

  def initialize(xl)
    @app = xl
    @obj = @open_type = @filename = nil
  end
  attr_accessor :app
  attr_accessor :obj
  attr_accessor :open_type
  attr_accessor :filename

  def close
    @app.book_close(self)
  end

  def save(save_name = nil)
    return  unless @obj
    da_v = @app.display_alert(false)
    if save_name == nil
      if @open_type == 'OPEN'
        ffmt = $ext_type[File.extname(@filename).downcase]
        if ffmt
          @obj.Saved = true
          @obj.SaveAs({'FileName'=>@filename, 'FileFormat'=>ffmt})
        else
          @obj.Save  # ㏑ۑ
        end
      elsif @app.excel_version >= 12.0  # Excel2007ȍ~
        outfile = filename_arrange(@filename)
        ffmt = $ext_type[File.extname(outfile).downcase]
        @obj.Saved = true
        @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
      else  # Excel2007O
        outfile = filename_arrange(@filename)
        ffmt = $ext_type[File.extname(outfile).downcase]
        @obj.Saved = true
        @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
      end
    else  # save_namew肳ꂽꍇ
      outfile = getAbsolutePath(save_name)
      if @app.excel_version >= 12.0  # Excel2007ȍ~
        ffmt = $ext_type[File.extname(outfile).downcase]
        unless ffmt
          outfile = filename_arrange(outfile)
          ffmt = $ext_type[File.extname(outfile).downcase]
        end
        @obj.Saved = true
        @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
      else
        ffmt = $ext_type[File.extname(outfile).downcase]
        unless ffmt
          outfile = filename_arrange(outfile)
          ffmt = $ext_type[File.extname(outfile).downcase]
        end
        @obj.Saved = true
        @obj.SaveAs({'FileName'=>outfile, 'FileFormat'=>ffmt})
      end
    end
    @app.display_alert(da_v)
  end

  def name  # [NubN̖O(tpXłȂEgq܂)Ԃ
    return  File.basename(@filename)
  end

  def sheet_names
    res = []
    return res  unless @obj
    for i in 1..@obj.Worksheets.Count
      res << @obj.Worksheets.Item(i).Name
    end
    return res
  end

  def sheet_number(sheet)
    i = self.sheet_names.index(sheet.Name)
    if i == nil
      i = 0
    else
      i += 1
    end
    return i
  end

  def offset_sheet(sheet, diff)
    rsheet = nil
    n = self.sheet_number(sheet)
    if n > 0 and (n + diff) > 0
      rsheet = self.select_sheet(n + diff)
    end
    return rsheet
  end

  def select_sheet(target)
    sheet = nil
    return sheet  unless @obj
    begin
      sheet = @obj.Worksheets.Item(target)
      sheet.extend Exlsheet
    rescue
      sheet = nil
    end
    return sheet
  end
  alias  :ss  :select_sheet

  def last_sheet
    target = sheet_names.size
    return select_sheet(target)
  end

  def add_sheet
    before = sheet_names
    sn = nil
    begin
      @obj.Worksheets.Add({'After'=>last_sheet})
      fore = sheet_names
      w = (fore - before)
      sn = w.shift  if w != nil and w.size > 0
    end
    return sn != nil ? select_sheet(sn) : nil
  end

  def insert_sheet(target)
    before = sheet_names
    sn = nil
    begin
      @obj.Worksheets.Add({'Before'=>select_sheet(target)})
      fore = sheet_names
      w = (fore - before)
      sn = w.shift  if w != nil and w.size > 0
    end
    return sn != nil ? select_sheet(sn) : nil
  end

  def delete_sheet(target)
    if @obj.Worksheets.Count > 1
      @app.display_alert(false) do
        sheet = select_sheet(target)
        sheet.Delete
      end
    end
  end

  def empty_sheet_names
    res = []
    aa = sheet_names
    aa.each {|sn|
      s = select_sheet sn
      y,x = s.range_last
      if y == 1 and x == 1 and s.Cells.Item(1,1).Value == nil and
         s.ChartObjects.Count == 0 and s.Shapes.Count == 0 and
         s.Hyperlinks.Count == 0 and s.QueryTables.Count == 0
        res << sn
      end
    }
    return res
  end

  def first_empty_sheet
    sheet = nil
    ary = self.empty_sheet_names  # ۂ̃V[g()̖OzŎ擾
    if ary.size > 0  # ۂ̃V[g݂ꍇ
      sn = ary.shift  # ŏ̋ۃV[g̖O𓾂
      sheet = self.select_sheet sn  # OsñV[gΏۂɂ
    else  # ۂ̃V[g݂Ȃꍇ
      sheet = self.add_sheet  # V[gǉĂ̖O𓾂
    end
    return sheet
  end
  alias :fes :first_empty_sheet

  def each
    return  unless block_given?
    self.sheet_names.each {|sn|
      yield self.select_sheet(sn)
    }
  end
end

# Excel Application߂̃NX
class Exlap
  include ExlConstant

  def initialize(*fname)
    @obj = nil
    @books = []
    begin
      @obj = WIN32OLE.new('Excel.Application')
      @obj.Visible = true
    rescue
      @obj = nil
    end
    if @obj and !(defined?($excel_version))
      unless defined?(ExlConstant::CONSTANTS)
        WIN32OLE.const_load(@obj, ExlConstant)
      end
      $excel_version = @obj.Version.to_f
      if $excel_version >= 12.0
        $ext_type = {".xls"=>XlExcel8,
                     ".xlsx"=>XlOpenXMLWorkbook,
                     ".xlsm"=>XlOpenXMLWorkbookMacroEnabled}
      else
        $ext_type = {".xls"=>XlExcel9795}
      end
    end
    if defined?(@obj) and fname.size > 0
      fname.each {|ff|
        wb = book_open(ff)
        yield wb  if block_given?
      }
      self.quit  if block_given?
    end
  end
  attr_accessor :obj

  def quit
    if @obj
      while wb = @books.shift
        book_close(wb)
        wb = nil
      end
      display_alert(false)
      @obj.Workbooks.Close
      @obj.Quit
      @obj = nil
    end
  end

  def opens(*fname)
    res = []
    if @obj != nil and fname.size > 0
      fname.each {|ff|
        wb = book_open(ff)
        if block_given?
          yield wb
        else
          res << wb
        end
      }
    end
    if res.size < 1
      res = nil
    end
    return res
  end

  def book_open(param)
    wb = nil
    fname = nil
    if param
      if param.class == String
        fname = param.dup
        param = Hash.new
      elsif param.class == Hash
        fname = param['Filename']
      else
        param = nil
      end
    end
    if @obj and param and fname
      fname = getAbsolutePath(fname)
      param['Filename'] = fname
      wb = select_wb(fname)
      unless wb  # ܂JĂȂubNł
        wb = Exlwb.new(self)
        if test(?e, fname)  # ̃t@CI[v
          display_alert(false) do
            wb.obj = @obj.Workbooks.Open(param)
            wb.open_type = 'OPEN'
          end
        else  # ݂Ȃt@CȂVK쐬
          wb.obj = @obj.Workbooks.Add()
          wb.open_type = 'ADD'
        end
        wb.filename = fname
      end
      if wb
        @books << wb
      end
    end
    return wb
  end

  def book_close(wb)
    if wb
      if wb.obj
        wb.obj.Saved = true
        wb.obj.Close
      end
      wb.app = wb.obj = wb.open_type = wb.filename = nil
      @books.delete(wb)
    end
  end

  def book_opentext(param)
    wb = nil
    fname = nil
    if param
      if param.class == String
        fname = param.dup
        param = Hash.new
      elsif param.class == Hash
        fname = param['Filename']
      else
        param = nil
      end
    end
    if @obj and param and fname
      fname = getAbsolutePath(fname)
      param['Filename'] = fname
      wb = select_wb(fname)
      unless wb  # ܂JĂȂubNł
        res = false
        display_alert(false) do
          if test(?e, fname)
            res = @obj.Workbooks.OpenText(param)
          end
        end
        if res == true
          wb = Exlwb.new(self)
          n = @obj.Workbooks.Count
          wb.obj = @obj.Workbooks(n)
          wb.filename = fname
          wb.open_type = 'OPEN'
        end
      end
      if wb
        @books << wb
      end
    end
    return wb
  end

  def select_wb(fname)  # tpXfnameƏƍ郏[NubNI
    wb = nil
    @books.each {|b|
      if b.filename.casecmp(fname) == 0
        wb = b
        break
      end
    }
    return wb
  end
  private :select_wb

  def select_book(target)
    wb = nil
    if target.class == String
      @books.each {|b|
        if b.name.casecmp(target) == 0
          wb = b
          break
        end
      }
    elsif [Fixnum,Bignum].include?(target.class)
      count = 0
      @books.each {|b|
        count += 1
        if count == target
          wb = b
          break
        end
      }
    end
    return wb
  end

  def book_names
    res = []
    @books.each {|b|
      res << b.name
    }
    return res
  end

  def display_alert(val)
    before_val = @obj.DisplayAlerts
    @obj.DisplayAlerts = val
    if block_given?
      yield
      @obj.DisplayAlerts = before_val
      return
    end
    return before_val
  end

  def each
    return  unless block_given?
    @books.each {|wb|
      yield wb
    }
  end

  def version  # exlap̃o[W
    return 1.03
  end

  def excel_version  # Excel̃o[W
    return @obj.Version.to_f
  end
end

include ExlConstant
